VERSION 5.00
Begin VB.Form frmConnect 
   BackColor       =   &H00C0C0C0&
   Caption         =   "DB Connection"
   ClientHeight    =   2940
   ClientLeft      =   1770
   ClientTop       =   1380
   ClientWidth     =   8520
   LinkTopic       =   "Form1"
   ScaleHeight     =   2940
   ScaleWidth      =   8520
   Begin VB.Frame frmAuthorization 
      Caption         =   "Authorization:"
      Height          =   2052
      Left            =   4200
      TabIndex        =   7
      Top             =   120
      Width           =   3855
      Begin VB.OptionButton optSSAuth 
         Caption         =   "Use S&QL Server authentication"
         Height          =   252
         Left            =   240
         TabIndex        =   13
         Top             =   720
         Width           =   3252
      End
      Begin VB.OptionButton optWinNTAuth 
         Caption         =   "Use &Windows NT authentication"
         Height          =   252
         Left            =   240
         TabIndex        =   12
         Top             =   360
         Width           =   2892
      End
      Begin VB.TextBox txtPassword 
         Height          =   288
         IMEMode         =   3  'DISABLE
         Left            =   1320
         PasswordChar    =   "*"
         TabIndex        =   11
         Top             =   1560
         Width           =   2292
      End
      Begin VB.TextBox txtUserName 
         Height          =   288
         Left            =   1320
         TabIndex        =   10
         Top             =   1080
         Width           =   2292
      End
      Begin VB.Label lblPassword 
         Caption         =   "Password:"
         Height          =   252
         Left            =   240
         TabIndex        =   9
         Top             =   1560
         Width           =   972
      End
      Begin VB.Label lblUserName 
         Caption         =   "&Login name:"
         Height          =   252
         Left            =   240
         TabIndex        =   8
         Top             =   1080
         Width           =   972
      End
   End
   Begin VB.Frame frmConnectionInfo 
      Caption         =   "Connection:"
      Height          =   2052
      Left            =   240
      TabIndex        =   2
      Top             =   120
      Width           =   3732
      Begin VB.TextBox txtDatabaseName 
         Height          =   288
         Left            =   1200
         TabIndex        =   6
         Top             =   1200
         Width           =   2172
      End
      Begin VB.TextBox txtServerName 
         Height          =   288
         Left            =   1200
         TabIndex        =   5
         Top             =   600
         Width           =   2172
      End
      Begin VB.Label Label2 
         Caption         =   "Database:"
         Height          =   255
         Left            =   240
         TabIndex        =   4
         Top             =   1200
         Width           =   855
      End
      Begin VB.Label Label1 
         Caption         =   "Server:"
         Height          =   255
         Left            =   240
         TabIndex        =   3
         Top             =   600
         Width           =   855
      End
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Co&nnect"
      Default         =   -1  'True
      Height          =   372
      Left            =   4815
      TabIndex        =   1
      Top             =   2295
      Width           =   1572
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Close"
      Height          =   372
      Left            =   6480
      TabIndex        =   0
      Top             =   2295
      Width           =   1572
   End
End
Attribute VB_Name = "frmConnect"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'AUTHOR: MATHEW GEORGE      CREATED: OCT 18, 2001
'MODS

Option Explicit

Dim Msg As String
Dim response As String

Const MsgConnSucc = "Connection to server successful."

Private Declare Function GetUserName Lib "advapi32.dll" _
  Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Private Sub cmdCancel_Click()

    Unload frmConnect
    
End Sub

Private Sub Form_Load()
    
    optSSAuth.Value = True
    SSAuthOptionsOn
    'Get from previous session
    txtUserName.Text = GetUserId
    txtPassword.Text = m_Pwd
    txtServerName.Text = m_SvrName
    txtDatabaseName.Text = m_DBName
    
End Sub


Private Sub cmdConnect_Click()
    ' Connect to server through SQL Server OLE DB Provider.
    
    On Error GoTo ErrorConnect:

    'Open previous connection if any
    If cn.State = adStateOpen Then
      cn.Close
    End If

    ' Put text box values into connection variables.
     m_SvrName = txtServerName.Text
     m_DBName = txtDatabaseName.Text
     m_UserId = txtUserName.Text
     m_Pwd = txtPassword.Text
     
     ' Set connection properties.
    cn.ConnectionTimeout = 25
    cn.Provider = "sqloledb"
    cn.Properties("Data Source").Value = m_SvrName
    cn.Properties("Initial Catalog").Value = m_DBName
    
    ' Decision code for login authorization type: WinNT or SQL Server.
    If optWinNTAuth.Value = True Then
        cn.Properties("Integrated Security").Value = "SSPI"
    Else
        cn.Properties("User ID").Value = m_UserId
        cn.Properties("Password").Value = m_Pwd
    End If
    
    ' Change mousepointer while trying to open database.
    Screen.MousePointer = vbHourglass
    
    ' Open the database.
    cn.Open
    
    ' Change mousepointer back to the default after open.
    Screen.MousePointer = vbDefault
    
    ' Notify user that connection was successful.
'    response = MsgBox(MsgConnSucc, vbOKOnly, Title)
    
    ' Close Window
    Unload frmConnect
    
    Exit Sub
   
ErrorConnect:
    
    ' Error checking. Connection successful.
    If cn.State = adStateOpen Then
        errcase = 1
    End If
    
    ' Error checking. Connection unsuccessful.
    If cn.State <> adStateOpen Then
        errcase = 2
    End If
    
    ' Go to general error-logging routine.
    ErrorLog
 
 End Sub

Private Sub cmdExit_Click()

    If cn.State = adStateOpen Then
      cn.Close
    End If
    End

End Sub

Private Sub optSSAuth_Click()
    If optSSAuth.Value = True Then
        SSAuthOptionsOn
        txtUserName.Text = GetUserId
        txtPassword.Text = m_Pwd
    End If
End Sub

Private Sub optWinNTAuth_Click()
    optWinNTAuth.Value = True
    WinNTAuthOptionsOn
    txtUserName.Text = ""
    txtPassword.Text = ""
End Sub

Private Sub WinNTAuthOptionsOn()
    lblUserName.Enabled = False
    lblPassword.Enabled = False
    txtUserName.Enabled = False
    txtPassword.Enabled = False
End Sub

Private Sub SSAuthOptionsOn()
    lblUserName.Enabled = True
    lblPassword.Enabled = True
    txtUserName.Enabled = True
    txtPassword.Enabled = True
End Sub


Private Function GetUserId() As String

    GetUserId = IIf(m_UserId = "", UserName, m_UserId)
End Function

Public Function UserName() As String
  ' Returns : The windows user name
  ' Source: Total Visual SourceBook 2000
  '
  Const cintStringLength As Integer = 100
  Dim strUserName As String * cintStringLength
  
  
  GetUserName strUserName, cintStringLength
  UserName = Trim(strUserName)

End Function
