VERSION 5.00
Object = "{0ECD9B60-23AA-11D0-B351-00A0C9055D8E}#6.0#0"; "MSHFLXGD.OCX"
Begin VB.Form frmMain 
   Caption         =   "MS SQL Stored Procedure Creator by Matt"
   ClientHeight    =   8595
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7380
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   8595
   ScaleWidth      =   7380
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdInsUpdSP 
      Caption         =   "Insert/Update SP"
      Height          =   330
      Left            =   5850
      TabIndex        =   14
      Top             =   630
      Width           =   1410
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   420
      Left            =   5580
      TabIndex        =   13
      Top             =   8145
      Width           =   1590
   End
   Begin VB.CommandButton cmdConnect 
      Caption         =   "Connect To New DB..."
      Height          =   375
      Left            =   45
      TabIndex        =   12
      Top             =   8145
      Width           =   2130
   End
   Begin VB.TextBox txtSP 
      Height          =   2400
      Left            =   45
      MultiLine       =   -1  'True
      TabIndex        =   11
      Top             =   5670
      Width           =   7125
   End
   Begin VB.CommandButton cmdBuild 
      Caption         =   "Build Stored Procedure"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4500
      TabIndex        =   10
      Top             =   5130
      Width           =   2535
   End
   Begin VB.CommandButton cmdDeleteSP 
      Caption         =   "Delete SP"
      Height          =   330
      Left            =   4410
      TabIndex        =   5
      Top             =   630
      Width           =   1275
   End
   Begin VB.CommandButton cmdUpdateSP 
      Caption         =   "Update SP"
      Height          =   330
      Left            =   3105
      TabIndex        =   4
      Top             =   630
      Width           =   1185
   End
   Begin VB.CommandButton cmdInsertSP 
      Caption         =   "Insert SP"
      Height          =   330
      Left            =   1575
      TabIndex        =   3
      Top             =   630
      Width           =   1365
   End
   Begin VB.TextBox txtTable 
      Height          =   330
      Left            =   2385
      TabIndex        =   1
      Top             =   180
      Width           =   2715
   End
   Begin MSHierarchicalFlexGridLib.MSHFlexGrid MSHFlexGrid1 
      Height          =   3120
      Left            =   135
      TabIndex        =   0
      Top             =   1620
      Width           =   6990
      _ExtentX        =   12330
      _ExtentY        =   5503
      _Version        =   393216
      Cols            =   4
      FixedCols       =   3
      FormatString    =   "                           Column Name                |   Column Type             |   Length  |     Parm Type"
      _NumberOfBands  =   1
      _Band(0).Cols   =   4
   End
   Begin VB.Label Label5 
      Caption         =   "5) Click Here To Build Stored Procedure ---->"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   240
      Left            =   90
      TabIndex        =   9
      Top             =   5220
      Width           =   4245
   End
   Begin VB.Label Label4 
      Caption         =   "4) Choose Template"
      Height          =   330
      Left            =   135
      TabIndex        =   8
      Top             =   4860
      Width           =   1545
   End
   Begin VB.Label Label3 
      Caption         =   "2) Choose Option:"
      Height          =   195
      Left            =   135
      TabIndex        =   7
      Top             =   720
      Width           =   1635
   End
   Begin VB.Label lblStep3 
      Caption         =   "3) Click on Input Parm Column to Set Parameter Type for Each Column"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   240
      Left            =   135
      TabIndex        =   6
      Top             =   1305
      Width           =   6810
   End
   Begin VB.Label Label1 
      Caption         =   "1) Enter Table Name:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   -1  'True
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FF0000&
      Height          =   285
      Left            =   135
      TabIndex        =   2
      Top             =   225
      Width           =   2130
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'AUTHOR: MATHEW GEORGE      CREATED: OCT 18, 2001
'MODS

Option Explicit

'Table Name
Private m_strTable As String
'Process selected 1 = insert; 2 = update ; 3 = delete; 4 = insert and update
Private Enum eProcess
    Insert
    Update
    Delete
    InsertAndUpdate
End Enum

Private m_Process As eProcess

'Declare the recorset to be used
Private m_rs As ADODB.Recordset
'

Const C_GetColsSQL As String = "select c.name, type = Case c.xtype WHEN 36 THEN 'uniqueidentifier' WHEN 48 THEN 'tinyint' WHEN 56 THEN 'integer' WHEN 58 THEN 'smalldatetime' WHEN 59 THEN 'real' WHEN 104 THEN 'bit' WHEN 239 THEN 'nchar' WHEN 231 THEN 'nvarchar' WHEN 175 THEN 'smalldatetime' ELSE cast(c.xtype AS nvarchar) End,  size =  Case c.xtype when 231 then prec Else: length End From syscolumns c, sysobjects o Where c.id = o.id and o.name = '<TABLE>' order by convert(int,colid)"

Private Sub cmdBuild_Click()

    'Call Build SP function
    BuildSP
    
End Sub

Private Sub cmdConnect_Click()

    'Call connect to DB window
    ConnectToDB
    
End Sub

Private Sub cmdExit_Click()

    Unload frmMain
    
End Sub

Private Sub cmdDeleteSP_Click()

    'Clear
    Call ClearAll
    
    'Get All Columns For Table
    If GetAllColumns() = -1 Then
        Beep
        txtTable.SetFocus
        Exit Sub
    End If
    
    'Set Module Flag to Insert
    m_Process = Delete
    
End Sub


Private Sub cmdInsertSP_Click()

    'Clear
    Call ClearAll
    
    'Get All Columns For Table
    If GetAllColumns() <= 0 Then
        Beep
        txtTable.SetFocus
        Exit Sub
    End If
    
    'Set Module Flag to Insert
    m_Process = Insert
    
End Sub

Private Sub cmdInsUpdSP_Click()


    'Clear
    Call ClearAll
    
    'Get All Columns For Table
    If GetAllColumns() <= 0 Then
        Beep
        txtTable.SetFocus
        Exit Sub
    End If
    
    'Set Module Flag to Insert+Update
    m_Process = InsertAndUpdate

End Sub

Private Sub cmdUpdateSP_Click()
    'Clear
    Call ClearAll

    'Get All Columns For Table
    If GetAllColumns() = -1 Then
        Beep
        txtTable.SetFocus
        Exit Sub
    End If

    'Set Applicable Labels for Steps
    
    'Set Module Flag to Update
    m_Process = Update
End Sub


Private Sub ClearAll()

Dim intRows As Long, i As Long

    'Clear Grid
    intRows = MSHFlexGrid1.Rows - 2
    For i = intRows To 1 Step -1
        Call MSHFlexGrid1.RemoveItem(i)
    Next
    
    'Clear SP Text Box
    txtSP.Text = ""
    
    cmdBuild.Enabled = False

End Sub

Private Function GetAllColumns() As Integer

Dim strSQL As String
Dim Rows As Long

    If txtTable.Text = "" Then
        MsgBox "Please enter a valid table name"
        GoTo EH_Err
    End If
    
    m_strTable = txtTable.Text
    
    'Create Getcolums String
    strSQL = C_GetColsSQL
    strSQL = Replace(strSQL, "<TABLE>", m_strTable)
        
    'Execute The SQL
    Rows = ExecuteSQL(strSQL)
    
    If Rows = 0 Then
        'Invalid Table
        cmdBuild.Enabled = False
        MsgBox "Please verify that the table exists"
        txtTable.SetFocus
        GoTo EH_Err
    Else
        'Populate Grid
        Call PopulateGrid
        cmdBuild.Enabled = True
        
    End If
    
EH_Exit:

    GetAllColumns = Rows
    
    Exit Function
    
EH_Err:

    GetAllColumns = -1
    
End Function


Private Sub Form_Load()

    'Store your Defaults here
    m_Pwd = ""
    m_SvrName = ""
    m_DBName = ""
    
    'Openn Connect to DB Window
    ConnectToDB
    
End Sub



Private Sub Form_Unload(Cancel As Integer)
    'Close Connection and End App
    Set m_rs = Nothing
    If cn.State = adStateOpen Then cn.Close
    End
End Sub

Private Sub ButtonSet(ByVal blnMode As Boolean)

    cmdDeleteSP.Enabled = blnMode
    cmdInsertSP.Enabled = blnMode
    cmdUpdateSP.Enabled = blnMode
    cmdInsUpdSP.Enabled = blnMode

End Sub

Private Sub ConnectToDB()

    'Display connection window
    frmConnect.Show vbModal
    
    'If connection is successful - enable all buttons
    If cn.State = adStateOpen Then
        ButtonSet True
    Else
        ButtonSet False  'else disable
    End If
    
End Sub

Private Function ExecuteSQL(ByVal cmd1 As String) As Long
'Execute a SQL and return all rows
    
    On Error GoTo ErrorExecute
                
    ' Change mousepointer to busy.
    Screen.MousePointer = vbHourglass
        
    ' Initialize recordset
    Set m_rs = New ADODB.Recordset
    
    m_rs.CursorType = adOpenStatic


    ' Open recordset.
    m_rs.Open cmd1, cn
          
    Screen.MousePointer = vbArrow
    
    ExecuteSQL = m_rs.RecordCount
    
    Exit Function

ErrorExecute:
    
    ' Error checking. Bad query.
    
    If cn.State = adStateOpen Then
        errcase = 3
    End If
    
    ExecuteSQL = 0
    ErrorLog
    
End Function


Private Sub PopulateGrid()

    Dim fldLoop As ADODB.Field
    
    Dim rowstring As String, rowvalue As String, rowcount As Long

    ' Move to fim_rst row.
    m_rs.MoveFirst
   
    ' Outermost loop handles multiple result sets per query cases.
    ' Variable "intcount" counts each result set in a query.
    ' 2nd Loop: loop through fields, concatenate values into rowstring variable.
    ' Place output into list box control.
    ' Go through all rows in open recordset.
    
    rowcount = 1
    Do While Not m_rs.EOF
            
        With m_rs
        
            rowvalue = ""
            rowstring = ""
                        
            ' Concatenate column values for each record.
            For Each fldLoop In m_rs.Fields
           
                ' Catch ADO Boolean type values, convert to VB string.
                If IsNull(fldLoop.Value) = True Then
                    rowvalue = "NULL"
                Else
                    rowvalue = fldLoop.Value
                End If
            
                rowstring = rowstring + rowvalue + vbTab
            Next fldLoop      ' End of inner loop.
            
            MSHFlexGrid1.AddItem rowstring, rowcount
            rowstring = ""
            rowcount = rowcount + 1
        End With
        m_rs.MoveNext
    Loop                    ' End of outer loop.

    'Remove the last blank row
    MSHFlexGrid1.RemoveItem (MSHFlexGrid1.Rows - 1)
    
    ' Change mousepointer to normal.
    Screen.MousePointer = vbDefault
    
    'Delete Recordset
    Set m_rs = Nothing
    

End Sub


Private Sub BuildSP()
    'Build The Stored Procedure
    Dim strSP As String
    Dim strHdr As String
    Dim strFirstPK As String
    
    Const strErr = vbTab & "IF @@ERROR <> 0" & vbNewLine & vbTab & vbTab & "RETURN @@ERROR" & vbNewLine & vbTab & "Else" & vbNewLine & vbTab & vbTab & "RETURN 0"
    Dim i As Long, Rows As Long, NewInsCtr As Integer, NewUpdCtr As Integer
    
    Dim strParms As String, strInsCols As String, strInsVals As String, strUpdCols As String
    Dim strWhereKeys As String
    
    'Do the header & ftr
    strHdr = "/*" & vbNewLine & "*   Author  : " & m_UserId & vbNewLine & "*   Date    : " & Format(Date, "ddd mm yyyy") & vbNewLine & "*   Purpose : " & GetSPName() & " " & m_strTable & vbNewLine & "*   Used In :" & vbNewLine & "*" & vbNewLine & "*   Revisions:" & vbNewLine & "*/" & vbNewLine & vbNewLine
    'Do the reSP
    strSP = "CREATE PROCEDURE sp_" & GetSPName() & Replace(m_strTable, "_", "") & vbNewLine & vbTab & "(" & vbNewLine

    'Count # of Columns in Table
    Rows = MSHFlexGrid1.Rows - 1
    
    'Initialize
    NewInsCtr = 1: NewUpdCtr = 1
    strInsCols = "": strInsVals = "": strUpdCols = "": strWhereKeys = ""
    strFirstPK = ""
    
    'Loop Thru Each Row
    For i = 1 To Rows
    
        'Ignore All Ignore Fields
        If MSHFlexGrid1.TextMatrix(i, 3) <> "Ignore" Then
        
            'Set the first PK or PK+AUTO Column for future use
            If strFirstPK = "" Then
                If MSHFlexGrid1.TextMatrix(i, 3) = "PK+AUTO" Or MSHFlexGrid1.TextMatrix(i, 3) = "PK" Then
                    strFirstPK = MSHFlexGrid1.TextMatrix(i, 0)
                End If
            End If
            
        
            'Create Parameter Columns
            Select Case m_Process
                Case Insert       'Insert Only
                    strParms = IIf(Len(strParms) > 0, strParms & "," & vbNewLine, "") & vbTab & "@" & MSHFlexGrid1.TextMatrix(i, 0) & vbTab & vbTab & MSHFlexGrid1.TextMatrix(i, 1) & IIf(MSHFlexGrid1.TextMatrix(i, 1) = "nvarchar", "(" & MSHFlexGrid1.TextMatrix(i, 2) & ")", "") & IIf((MSHFlexGrid1.TextMatrix(i, 3) = "PK+AUTO"), " = NULL", "")
    
                Case InsertAndUpdate       'Insert & Update
                    strParms = IIf(Len(strParms) > 0, strParms & "," & vbNewLine, "") & vbTab & "@" & MSHFlexGrid1.TextMatrix(i, 0) & vbTab & vbTab & MSHFlexGrid1.TextMatrix(i, 1) & IIf(MSHFlexGrid1.TextMatrix(i, 1) = "nvarchar", "(" & MSHFlexGrid1.TextMatrix(i, 2) & ")", "") & IIf((MSHFlexGrid1.TextMatrix(i, 3) = "PK+AUTO" Or MSHFlexGrid1.TextMatrix(i, 3) = "PK"), " = NULL", "")
                    'Use Auto & PK Keys in Where Clause
                    If MSHFlexGrid1.TextMatrix(i, 3) = "PK+AUTO" Or MSHFlexGrid1.TextMatrix(i, 3) = "PK" Then
                        strWhereKeys = IIf(Len(strWhereKeys) > 0, strWhereKeys & " AND ", "") & MSHFlexGrid1.TextMatrix(i, 0) & " = @" & MSHFlexGrid1.TextMatrix(i, 0)
                    End If
    
                Case Update
                    strParms = IIf(Len(strParms) > 0, strParms & "," & vbNewLine, "") & vbTab & "@" & MSHFlexGrid1.TextMatrix(i, 0) & vbTab & vbTab & MSHFlexGrid1.TextMatrix(i, 1) & IIf(MSHFlexGrid1.TextMatrix(i, 1) = "nvarchar", "(" & MSHFlexGrid1.TextMatrix(i, 2) & ")", "")
                    'Use PK Keys in where Clause
                    If MSHFlexGrid1.TextMatrix(i, 3) = "PK" Then
                        strWhereKeys = IIf(Len(strWhereKeys) > 0, strWhereKeys & " AND ", "") & MSHFlexGrid1.TextMatrix(i, 0) & " = @" & MSHFlexGrid1.TextMatrix(i, 0)
                    End If
    
                Case Else       'Delete Only Use Marked Cols
                    If MSHFlexGrid1.TextMatrix(i, 3) = "PK" Then
                        strParms = IIf(Len(strParms) > 0, strParms & "," & vbNewLine, "") & vbTab & "@" & MSHFlexGrid1.TextMatrix(i, 0) & vbTab & vbTab & MSHFlexGrid1.TextMatrix(i, 1) & IIf(MSHFlexGrid1.TextMatrix(i, 1) = "nvarchar", "(" & MSHFlexGrid1.TextMatrix(i, 2) & ")", "")
                        strWhereKeys = IIf(Len(strWhereKeys) > 0, strWhereKeys & " AND ", "") & MSHFlexGrid1.TextMatrix(i, 0) & " = @" & MSHFlexGrid1.TextMatrix(i, 0)
                    End If
            End Select
            
            'Create other INSERT & UPDATE Parms
            If m_Process = Insert Or m_Process = InsertAndUpdate Then
                If MSHFlexGrid1.TextMatrix(i, 3) <> "PK+AUTO" Then  'Ignore PK + Auto fields
                    strInsCols = IIf(Len(strInsCols) > 0, strInsCols & ", ", "") & MSHFlexGrid1.TextMatrix(i, 0)
                    strInsVals = IIf(Len(strInsVals) > 0, strInsVals & ", ", "") & "@" & MSHFlexGrid1.TextMatrix(i, 0)
                End If
                'DO FORMATTING OF STRING
                If (Len(strInsCols)) > (60 * NewInsCtr) Then
                    strInsCols = strInsCols & vbNewLine & vbTab & vbTab & vbTab
                    strInsVals = strInsVals & vbNewLine & vbTab & vbTab & vbTab
                    NewInsCtr = NewInsCtr + 1
                End If
            End If
            If m_Process = Update Or m_Process = InsertAndUpdate Then
                'Ignore PK Fields & PK + Autp Fields in Update
                If MSHFlexGrid1.TextMatrix(i, 3) = "PK+AUTO" Or MSHFlexGrid1.TextMatrix(i, 3) = "PK" Then   'Ignore PK + Auto fields
                    'Ignore
                Else
                    strUpdCols = IIf(Len(strUpdCols) > 0, strUpdCols & ", ", "") & MSHFlexGrid1.TextMatrix(i, 0) & " = @" & MSHFlexGrid1.TextMatrix(i, 0)
                    'DO FORMATTING OF STRING
                    If Len(strUpdCols) > (80 * NewUpdCtr) Then
                        strUpdCols = strUpdCols & vbNewLine & vbTab & vbTab & vbTab
                        NewUpdCtr = NewUpdCtr + 1
                    End If
                End If
            End If
        
        End If      'Do Not Process Any <Ignore> Columns
    Next i
    
    
    'If there are no Primary Keys selected for 2, 3, or 4 Display Message and exit
    If m_Process > 1 Then
        If strFirstPK = "" Then
            MsgBox "Please select <Parm Type> for atleast one column as PK+AUTO or PK"
            Exit Sub
        End If
    End If
    
    
    strSP = strSP & strParms & vbNewLine & vbTab & ")" & vbNewLine & "AS" & vbNewLine & vbTab & "SET NOCOUNT ON" & vbNewLine & vbNewLine
    If m_Process = Insert Or m_Process = InsertAndUpdate Then
        If m_Process = InsertAndUpdate And strFirstPK <> "" Then
            strSP = strSP & vbTab & "IF @" & strFirstPK & " IS NULL" & vbNewLine & vbTab & vbTab & "-- record does not exist do insert" & vbNewLine
        End If
        strSP = strSP & vbTab & vbTab & "INSERT INTO " & m_strTable & vbNewLine
        strSP = strSP & vbTab & vbTab & vbTab & "(" & strInsCols & ")" & vbNewLine
        strSP = strSP & vbTab & vbTab & "VALUES (" & strInsVals & ")" & vbNewLine
    End If
    If m_Process = InsertAndUpdate Then
        strSP = strSP & vbTab & "ELSE" & vbNewLine & vbTab & vbTab & "-- record exists do update" & vbNewLine
    End If
    If m_Process = Update Or m_Process = InsertAndUpdate Then
        strSP = strSP & vbTab & vbTab & "UPDATE " & m_strTable & vbNewLine
        strSP = strSP & vbTab & vbTab & "SET " & strUpdCols
        strSP = strSP & vbNewLine & vbTab & vbTab & "WHERE " & strWhereKeys & vbNewLine
    End If
    
    If m_Process = Delete Then
        strSP = strSP & vbTab & "DELETE * FROM " & m_strTable & vbNewLine
        strSP = strSP & vbTab & "WHERE " & strWhereKeys & vbNewLine
    End If
    
    'Error Handler
    strSP = strSP & vbNewLine & strErr
    
    'Final statement
    strSP = strSP & vbNewLine & vbNewLine & "GO"

    txtSP.Text = strHdr & vbNewLine & strSP
    
End Sub

Private Sub MSHFlexGrid1_Click()
'SMART GRID EDITING

    'Support Editing of Column Parm
    If m_Process = Delete Then        'For Delete allow only PK
    
        If MSHFlexGrid1.Row > 0 Then
            'MSHFlexGrid1.EditCell
            If MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK"
            Else
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = ""
            End If
        End If
    ElseIf m_Process = Update Then        'For Update allow only PK & IGNORE
    
        If MSHFlexGrid1.Row > 0 Then
            'MSHFlexGrid1.EditCell
            If MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "Ignore"
            Else
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = ""
            End If
        End If
    
    ElseIf m_Process = Insert Then        'For Update allow only PK & IGNORE
    
        If MSHFlexGrid1.Row > 0 Then
            'MSHFlexGrid1.EditCell
            If MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK+AUTO"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK+AUTO" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "Ignore"
            Else
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = ""
            End If
        End If
    
    Else        'INSERT & Insert/Update
    
        If MSHFlexGrid1.Row = 1 Then
            'MSHFlexGrid1.EditCell
            If MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK+AUTO"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK+AUTO" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "Ignore"
            Else
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = ""
            End If
        Else
            'MSHFlexGrid1.EditCell
            If MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "Ignore"
            ElseIf MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "Ignore" Then
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = "PK+AUTO"
            Else
                MSHFlexGrid1.TextMatrix(MSHFlexGrid1.Row, 3) = ""
            End If
        End If
    End If
    
End Sub


Private Function GetSPName() As String


    Select Case m_Process
        Case Insert
            GetSPName = "Insert"
        Case Delete
            GetSPName = "Delete"
        Case Else
            GetSPName = "Update"
    End Select
    
End Function

